// test_name.cpp
// Glenn G. Chappell
// 17 Sep 2013
//
// For CS 202 Fall 2013
// Test program for class Name

#include "name.h"  // For class Name
#include "name.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testName1
// Test #1 for class Name
// Prints results of tests, sets global allGood to false if any fail
void testName1()
{
    cout << endl;
    cout << "Test 1" << endl;

    Name n("Fred", "Smurd", false);
    const Name & cn(n);

    string fn = cn.getFname();
    cout << "First name (should be \"Fred\"): " << fn << endl;
    if (fn != "Fred")
        allGood = false;

    string ln = cn.getLname();
    cout << "Last name (should be \"Smurd\"): " << ln << endl;
    if (ln != "Smurd")
        allGood = false;

    bool fem = cn.getFemale();
    cout << "Female? (should be \"false\"): " << (fem ? "true" : "false")
         << endl;
    if (fem)
        allGood = false;

    ostringstream ostr;
    cn.printFull(ostr);
    string full = ostr.str();
    cout << "Full name (should be \"Mr. Fred Smurd\"): " << full << endl;
    if (full != "Mr. Fred Smurd")
        allGood = false;
}


// testName2
// Test #2 for class Name
// Prints results of tests, sets global allGood to false if any fail
void testName2()
{
    cout << endl;
    cout << "Test 2" << endl;

    Name n;
    const Name & cn(n);

    n.setFname("Ethel");
    n.setLname("Murgatroyd");
    n.setFemale(true);

    string fn = cn.getFname();
    cout << "First name (should be \"Ethel\"): " << fn << endl;
    if (fn != "Ethel")
        allGood = false;

    string ln = cn.getLname();
    cout << "Last name (should be \"Murgatroyd\"): " << ln << endl;
    if (ln != "Murgatroyd")
        allGood = false;

    bool fem = cn.getFemale();
    cout << "Female? (should be \"true\"): " << (fem ? "true" : "false")
         << endl;
    if (!fem)
        allGood = false;

    ostringstream ostr;
    cn.printFull(ostr);
    string full = ostr.str();
    cout << "Full name (should be \"Ms. Ethel Murgatroyd\"): " << full << endl;
    if (full != "Ms. Ethel Murgatroyd")
        allGood = false;
}


// main program
// Runs tests for class Name, prints results
int main()
{
    testName1();
    testName2();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

